-- ============================================================
--   Database name:  HISCATALOG                                
--   DBMS name:      ORACLE Version 7.x                        
--   Created on:     9/29/99  3:56 PM                          
-- ============================================================

-- ============================================================
--   Table: CB_CONCURRENCY                                     
-- ============================================================
create table CB_CONCURRENCY
(
    CB_USER_NAME        VARCHAR2(30)           not null,
    CB_USER_SESSION_ID  INTEGER                not null,
    CB_OBJECT_ID        INTEGER                not null,
    CB_OBJECT_TYPE      INTEGER                not null,
    CB_OBJECT_LOCK      INTEGER                not null,
    CB_LOCK_TIMESTAMP   DATE               not null,
    constraint PK_CB_CONCURRENCY primary key (CB_USER_NAME, CB_USER_SESSION_ID, CB_OBJECT_ID, CB_OBJECT_TYPE)
)
/

-- ============================================================
--   Table: CB_VERSION                                         
-- ============================================================
create table CB_VERSION
(
    MD_VERSION          VARCHAR2(30)           not null,
    MD_VERSION_DATE     DATE               not null,
    constraint PK_CB_VERSION primary key (MD_VERSION)
)
/

-- ============================================================
--   Table: OM_INFO                                            
-- ============================================================
create table OM_INFO
(
    MODEL_ID            INTEGER                not null,
    MODEL_NAME          VARCHAR2(80)           not null,
    MODEL_DESCRIPTION   VARCHAR2(255)          null    ,
    MODEL_DATA_SOURCE   VARCHAR2(255)          not null,
    MODEL_OWNER         VARCHAR2(30)           not null,
    MODEL_ACCESS_CODE   INTEGER                not null,
    MODEL_DATA_SRCTYPE  INTEGER                not null,
    MODEL_DB_HINT       VARCHAR2(255)          null    ,
    constraint PK_OM_INFO primary key (MODEL_ID)
)
/

-- ============================================================
--   Table: OD_INFO                                            
-- ============================================================
create table OD_INFO
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    DIMENSION_NAME      VARCHAR2(80)           not null,
    DIMENSION_TYPE      INTEGER                not null,
    constraint PK_OD_INFO primary key (MODEL_ID, DIMENSION_ID)
)
/

-- ============================================================
--   Table: OVL_REL_INFO                                       
-- ============================================================
create table OVL_REL_INFO
(
    MODEL_ID            INTEGER                not null,
    LOG_RELATION_ID     INTEGER                not null,
    LOG_VIEW_1          INTEGER                not null,
    LOG_VIEW_2          INTEGER                not null,
    constraint PK_OVL_REL_INFO primary key (MODEL_ID, LOG_RELATION_ID)
)
/

-- ============================================================
--   Table: OV_INFO                                            
-- ============================================================
create table OV_INFO
(
    MODEL_ID            INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    VIEW_NAME           VARCHAR2(30)           not null,
    VIEW_DCX            INTEGER                not null,
    VIEW_DCY            INTEGER                not null,
    VIEW_TYPE           INTEGER                not null,
    constraint PK_OV_INFO primary key (MODEL_ID, VIEW_ID)
)
/

-- ============================================================
--   Table: MO_INFO                                            
-- ============================================================
create table MO_INFO
(
    MO_ID               INTEGER                not null,
    MODEL_ID            INTEGER                not null,
    MO_NAME             VARCHAR2(80)           not null,
    MO_DESC             VARCHAR2(255)          null    ,
    MO_CHANGE_DATE      DATE                   not null,
    MO_OWNER            VARCHAR2(30)           not null,
    MO_ACCESS_CODE      INTEGER                not null,
    DT_CBS_PROMPT       INTEGER                not null,
    DT_SRC_PROMPT       INTEGER                not null,
    constraint PK_MO_INFO primary key (MO_ID)
)
/

-- ============================================================
--   Table: OMB_INFO                                           
-- ============================================================
create table OMB_INFO
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    MODEL_BLOCK_ID      INTEGER                not null,
    MODEL_BLOCK_NAME    VARCHAR2(255)          not null,
    constraint PK_OMB_INFO primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID)
)
/

-- ============================================================
--   Table: OMB_DETAILS                                        
-- ============================================================
create table OMB_DETAILS
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    MODEL_BLOCK_ID      INTEGER                not null,
    MB_ATTRIBUTE_ID     INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    ATTRIBUTE_ID        INTEGER                not null,
    MB_ATTRIBUTE_LVL    INTEGER                not null,
    MB_BUILD_ORDER      INTEGER                not null,
    constraint PK_OMB_DETAILS primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID)
)
/

-- ============================================================
--   Table: OA_INFO                                            
-- ============================================================
create table OA_INFO
(
    MODEL_ID            INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    ATTRIBUTE_ID        INTEGER                not null,
    ATTRIBUTE_NAME      VARCHAR2(80)           not null,
    ATTRIBUTE_DATATYPE  VARCHAR2(10)           not null,
    AGGREGATE_TYPE      VARCHAR2(10)           not null,
    PHYSICAL_TABLE      VARCHAR2(255)          not null,
    PHYSICAL_COLUMN     VARCHAR2(30)           not null,
    ATTRIBUTE_DISPLAY   INTEGER                not null,
    ATTRIBUTE_TYPE      INTEGER                not null,
    ATTRIBUTE_EX_RULE   VARCHAR2(255)          null    ,
    constraint PK_OA_INFO primary key (MODEL_ID, VIEW_ID, ATTRIBUTE_ID)
)
/

-- ============================================================
--   Table: OVP_REL_INFO                                       
-- ============================================================
create table OVP_REL_INFO
(
    MODEL_ID            INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    PHY_RELATION_ID     INTEGER                not null,
    PHY_REL_TYPE        INTEGER                not null,
    PHY_TABLE_1         VARCHAR2(255)          not null,
    PHY_TABLE_2         VARCHAR2(255)          not null,
    constraint PK_OVP_REL_INFO primary key (MODEL_ID, VIEW_ID, PHY_RELATION_ID)
)
/

-- ============================================================
--   Table: MOD_INFO                                           
-- ============================================================
create table MOD_INFO
(
    MO_ID               INTEGER                not null,
    MOD_ID              INTEGER                not null,
    DIMENSION_ID        INTEGER                null    ,
    MOD_TYPE            INTEGER                not null,
    MOD_NAME            VARCHAR2(80)           not null,
    MOD_SEQ_NUMBER      INTEGER                not null,
    constraint PK_MOD_INFO primary key (MO_ID, MOD_ID)
)
/

-- ============================================================
--   Table: MSR_INFO                                           
-- ============================================================
create table MSR_INFO
(
    MO_ID               INTEGER                not null,
    MSR_ID              INTEGER                not null,
    MSR_NAME            VARCHAR2(80)           not null,
    MSR_SEQ_NUMBER      INTEGER                not null,
    MSR_VIEW_ID         INTEGER                not null,
    MSR_ATTRIBUTE_ID    INTEGER                not null,
    constraint PK_MSR_INFO primary key (MO_ID, MSR_ID)
)
/

-- ============================================================
--   Table: MO_FILTERS                                         
-- ============================================================
create table MO_FILTERS
(
    MO_ID               INTEGER                not null,
    FLT_ID              INTEGER                not null,
    FLT_TYPE            INTEGER                not null,
    FLT_NAME            VARCHAR2(80)           null    ,
    constraint PK_MO_FILTERS primary key (MO_ID, FLT_ID)
)
/

-- ============================================================
--   Table: DTR_INFO                                           
-- ============================================================
create table DTR_INFO
(
    MO_ID               INTEGER                not null,
    DTR_ID              INTEGER                not null,
    DTR_NAME            VARCHAR2(80)           not null,
    DTR_SKIP_WIZARD     INTEGER                not null,
    DTR_ROW_GOVERNOR    INTEGER                not null,
    DTR_TIME_GOVERNOR   INTEGER                not null,
    constraint PK_DTR_INFO primary key (MO_ID, DTR_ID)
)
/

-- ============================================================
--   Table: MS_INFO                                            
-- ============================================================
create table MS_INFO
(
    MO_ID               INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MS_ID               INTEGER                not null,
    MS_TYPE             INTEGER                not null,
    MS_NAME             VARCHAR2(80)           not null,
    MS_PARENT_ID        INTEGER                not null,
    MS_SEQ_NUMBER       INTEGER                not null,
    MS_MSR_ID           INTEGER                not null,
    MS_VIEW_ID          INTEGER                not null,
    MS_ATTRIBUTE_ID     INTEGER                not null,
    constraint PK_MS_INFO primary key (MO_ID, MOD_ID, MS_ID)
)
/

-- ============================================================
--   Table: OD_DETAILS                                         
-- ============================================================
create table OD_DETAILS
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    DIM_DETAIL_ID       INTEGER                not null,
    VIEW_ID             INTEGER                null    ,
    DIM_PARENT_VIEW_ID  INTEGER                not null,
    constraint PK_OD_DETAILS primary key (MODEL_ID, DIMENSION_ID, DIM_DETAIL_ID)
)
/

-- ============================================================
--   Table: OVL_REL_DETAILS                                    
-- ============================================================
create table OVL_REL_DETAILS
(
    MODEL_ID            INTEGER                not null,
    LOG_RELATION_ID     INTEGER                not null,
    LOG_REL_DET_ID      INTEGER                not null,
    LOG_ATTRIBUTE_1     INTEGER                not null,
    LOG_ATTRIBUTE_2     INTEGER                not null,
    constraint PK_OVL_REL_DETAILS primary key (MODEL_ID, LOG_RELATION_ID, LOG_REL_DET_ID)
)
/

-- ============================================================
--   Table: OVP_REL_DETAILS                                    
-- ============================================================
create table OVP_REL_DETAILS
(
    MODEL_ID            INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    PHY_RELATION_ID     INTEGER                not null,
    PHY_REL_DET_ID      INTEGER                not null,
    PHY_COLUMN_1        VARCHAR2(30)           not null,
    PHY_COLUMN_2        VARCHAR2(30)           not null,
    constraint PK_OVP_REL_DETAILS primary key (MODEL_ID, VIEW_ID, PHY_RELATION_ID, PHY_REL_DET_ID)
)
/

-- ============================================================
--   Table: MO_PROPERTIES                                      
-- ============================================================
create table MO_PROPERTIES
(
    MO_ID               INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MS_ID               INTEGER                not null,
    PRP_CODE            INTEGER                not null,
    PRP_CD_INS_NUMBER   INTEGER                not null,
    PRP_CD_SEQ_NUMBER   INTEGER                not null,
    PRP_VALUE           VARCHAR2(255)          null    ,
    PRP_VIEW_ID         INTEGER                not null,
    PRP_ATTRIBUTE_ID    INTEGER                not null,
    constraint PK_MO_PROPERTIES primary key (MO_ID, MOD_ID, MS_ID, PRP_CODE, PRP_CD_INS_NUMBER, PRP_CD_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MS_TX_RULE                                         
-- ============================================================
create table MS_TX_RULE
(
    MO_ID               INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MS_ID               INTEGER                not null,
    TXR_SEQ_NUMBER      INTEGER                not null,
    TXR_DEFINITION      VARCHAR2(255)          not null,
    constraint PK_MS_TX_RULE primary key (MO_ID, MOD_ID, MS_ID, TXR_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MSR_TX_RULE                                        
-- ============================================================
create table MSR_TX_RULE
(
    MO_ID               INTEGER                not null,
    MSR_ID              INTEGER                not null,
    MSR_TXR_SEQ_NUMBER  INTEGER                not null,
    MSR_TXR_DEFINITION  VARCHAR2(255)          not null,
    constraint PK_MSR_TX_RULE primary key (MO_ID, MSR_ID, MSR_TXR_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MB_TX_RULE                                         
-- ============================================================
create table MB_TX_RULE
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    MODEL_BLOCK_ID      INTEGER                not null,
    MB_ATTRIBUTE_ID     INTEGER                not null,
    MB_TXR_SEQ_NUMBER   INTEGER                not null,
    MB_TXR_DEFINITION   VARCHAR2(255)          not null,
    constraint PK_MB_TX_RULE primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID, MB_TXR_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MB_FILTER                                          
-- ============================================================
create table MB_FILTER
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    MODEL_BLOCK_ID      INTEGER                not null,
    MB_ATTRIBUTE_ID     INTEGER                not null,
    MBF_SEQ_NUMBER      INTEGER                not null,
    MBF_DEFINITION      VARCHAR2(255)          not null,
    constraint PK_MB_FILTER primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID, MBF_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MS_PREDICATES                                      
-- ============================================================
create table MS_PREDICATES
(
    MO_ID               INTEGER                not null,
    FLT_ID              INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MS_ID               INTEGER                not null,
    MS_PRD_TYPE         INTEGER                not null,
    MS_PRD_SEQ_NUMBER   INTEGER                not null,
    MS_PRD_DEFINITION   VARCHAR2(255)          not null,
    constraint PK_MS_PREDICATES primary key (MO_ID, FLT_ID, MOD_ID, MS_ID, MS_PRD_TYPE, MS_PRD_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MSR_PREDICATES                                     
-- ============================================================
create table MSR_PREDICATES
(
    MO_ID               INTEGER                not null,
    FLT_ID              INTEGER                not null,
    MSR_ID              INTEGER                not null,
    MSR_PRD_SEQ_NUMBER  INTEGER                not null,
    MSR_PRD_DEFINITION  VARCHAR2(255)          not null,
    constraint PK_MSR_PREDICATES primary key (MO_ID, FLT_ID, MSR_ID, MSR_PRD_SEQ_NUMBER)
)
/

-- ============================================================
--   Table: MO_INTERSECTION                                    
-- ============================================================
create table MO_INTERSECTION
(
    MO_ID               INTEGER                not null,
    DTR_ID              INTEGER                not null,
    DTI_MOD_ID          INTEGER                not null,
    DTI_MS_ID           INTEGER                not null,
    constraint PK_MO_INTERSECTION primary key (MO_ID, DTR_ID, DTI_MOD_ID, DTI_MS_ID)
)
/

-- ============================================================
--   Table: DTR_ATTRIBUTES                                     
-- ============================================================
create table DTR_ATTRIBUTES
(
    MO_ID               INTEGER                not null,
    DTR_ID              INTEGER                not null,
    DTR_VIEW_ID         INTEGER                not null,
    DTR_ATTRIBUTE_ID    INTEGER                not null,
    DTR_DISP_ORDER      INTEGER                not null,
    DTR_SORT_ORDER      INTEGER                not null,
    DTR_ORDER_BY        INTEGER                not null,
    constraint PK_DTR_ATTRIBUTES primary key (MO_ID, DTR_ID, DTR_VIEW_ID, DTR_ATTRIBUTE_ID)
)
/

-- ============================================================
--   Table: JOIN_HINTS                                         
-- ============================================================
create table JOIN_HINTS
(
    MODEL_ID            INTEGER                not null,
    HINT_VIEW_ID        INTEGER                not null,
    JOIN_TYPE           INTEGER                not null,
    JOIN_ID             INTEGER                not null,
    PHYSICAL_TABLE      VARCHAR2(255)          not null,
    HINT_TEXT           VARCHAR2(255)          not null,
    HINT_ID             INTEGER                not null,
    constraint PK_JOIN_HINTS primary key (MODEL_ID, HINT_VIEW_ID, JOIN_TYPE, JOIN_ID, HINT_ID)
)
/

-- ============================================================
--   Table: OM_DESCRIPTIONS                                    
-- ============================================================
create table OM_DESCRIPTIONS
(
    MODEL_ID            INTEGER                not null,
    DIMENSION_ID        INTEGER                not null,
    VIEW_ID             INTEGER                not null,
    ATTRIBUTE_ID        INTEGER                not null,
    MODEL_BLOCK_ID      INTEGER                not null,
    DESCRIPTION         VARCHAR2(255)          null    ,
    constraint PK_OM_DESCRIPTIONS primary key (MODEL_ID, DIMENSION_ID, VIEW_ID, ATTRIBUTE_ID, MODEL_BLOCK_ID)
)
/

-- ============================================================
--   Table: MOD_ATTRIBUTES                                     
-- ============================================================
create table MOD_ATTRIBUTES
(
    MO_ID               INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MOD_ATTRIBUTE_ID    INTEGER                not null,
    MOD_ATTR_DATATYPE   INTEGER                not null,
    MOD_ATTR_ALIAS      VARCHAR2(80)           null    ,
    MOD_ATTR_TXR        VARCHAR2(255)          null    ,
    constraint PK_MOD_ATTRIBUTES primary key (MO_ID, MOD_ATTRIBUTE_ID)
)
/

-- ============================================================
--   Table: MO_DESCRIPTIONS                                    
-- ============================================================
create table MO_DESCRIPTIONS
(
    MO_ID               INTEGER                not null,
    FLT_ID              INTEGER                not null,
    MOD_ID              INTEGER                not null,
    MS_ID               INTEGER                not null,
    DESCRIPTIONS        VARCHAR2(255)          null    ,
    constraint PK_MO_DESCRIPTIONS primary key (MO_ID, FLT_ID, MOD_ID, MS_ID)
)
/

