/* ============================================================ */
/*   Database name:  HISCATALOG                                 */
/*   DBMS name:      Microsoft SQL Server 6.x                   */
/*   Created on:     9/29/99  3:51 PM                           */
/* ============================================================ */

/* ============================================================ */
/*   Table: CB_CONCURRENCY                                      */
/* ============================================================ */
create table CB_CONCURRENCY
(
    CB_USER_NAME        varchar(30)           not null,
    CB_USER_SESSION_ID  integer               not null,
    CB_OBJECT_ID        integer               not null,
    CB_OBJECT_TYPE      integer               not null,
    CB_OBJECT_LOCK      integer               not null,
    CB_LOCK_TIMESTAMP   datetime              not null,
    constraint PK_CB_CONCURRENCY primary key (CB_USER_NAME, CB_USER_SESSION_ID, CB_OBJECT_ID, CB_OBJECT_TYPE)
)
go

/* ============================================================ */
/*   Table: CB_VERSION                                          */
/* ============================================================ */
create table CB_VERSION
(
    MD_VERSION          varchar(30)           not null,
    MD_VERSION_DATE     datetime              not null,
    constraint PK_CB_VERSION primary key (MD_VERSION)
)
go

/* ============================================================ */
/*   Table: OM_INFO                                             */
/* ============================================================ */
create table OM_INFO
(
    MODEL_ID            integer               not null,
    MODEL_NAME          varchar(80)           not null,
    MODEL_DESCRIPTION   varchar(255)          null    ,
    MODEL_DATA_SOURCE   varchar(255)          not null,
    MODEL_OWNER         varchar(30)           not null,
    MODEL_ACCESS_CODE   integer               not null,
    MODEL_DATA_SRCTYPE  integer               not null,
    MODEL_DB_HINT       varchar(255)          null    ,
    constraint PK_OM_INFO primary key (MODEL_ID)
)
go

/* ============================================================ */
/*   Table: OD_INFO                                             */
/* ============================================================ */
create table OD_INFO
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    DIMENSION_NAME      varchar(80)           not null,
    DIMENSION_TYPE      integer               not null,
    constraint PK_OD_INFO primary key (MODEL_ID, DIMENSION_ID)
)
go

/* ============================================================ */
/*   Table: OVL_REL_INFO                                        */
/* ============================================================ */
create table OVL_REL_INFO
(
    MODEL_ID            integer               not null,
    LOG_RELATION_ID     integer               not null,
    LOG_VIEW_1          integer               not null,
    LOG_VIEW_2          integer               not null,
    constraint PK_OVL_REL_INFO primary key (MODEL_ID, LOG_RELATION_ID)
)
go

/* ============================================================ */
/*   Table: OV_INFO                                             */
/* ============================================================ */
create table OV_INFO
(
    MODEL_ID            integer               not null,
    VIEW_ID             integer               not null,
    VIEW_NAME           varchar(30)           not null,
    VIEW_DCX            integer               not null,
    VIEW_DCY            integer               not null,
    VIEW_TYPE           integer               not null,
    constraint PK_OV_INFO primary key (MODEL_ID, VIEW_ID)
)
go

/* ============================================================ */
/*   Table: MO_INFO                                             */
/* ============================================================ */
create table MO_INFO
(
    MO_ID               integer               not null,
    MODEL_ID            integer               not null,
    MO_NAME             varchar(80)           not null,
    MO_DESC             varchar(255)          null    ,
    MO_CHANGE_DATE      datetime              not null,
    MO_OWNER            varchar(30)           not null,
    MO_ACCESS_CODE      integer               not null,
    DT_CBS_PROMPT       integer               not null,
    DT_SRC_PROMPT       integer               not null,
    constraint PK_MO_INFO primary key (MO_ID)
)
go

/* ============================================================ */
/*   Table: OMB_INFO                                            */
/* ============================================================ */
create table OMB_INFO
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    MODEL_BLOCK_ID      integer               not null,
    MODEL_BLOCK_NAME    varchar(255)          not null,
    constraint PK_OMB_INFO primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID)
)
go

/* ============================================================ */
/*   Table: OMB_DETAILS                                         */
/* ============================================================ */
create table OMB_DETAILS
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    MODEL_BLOCK_ID      integer               not null,
    MB_ATTRIBUTE_ID     integer               not null,
    VIEW_ID             integer               not null,
    ATTRIBUTE_ID        integer               not null,
    MB_ATTRIBUTE_LVL    integer               not null,
    MB_BUILD_ORDER      integer               not null,
    constraint PK_OMB_DETAILS primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID)
)
go

/* ============================================================ */
/*   Table: OA_INFO                                             */
/* ============================================================ */
create table OA_INFO
(
    MODEL_ID            integer               not null,
    VIEW_ID             integer               not null,
    ATTRIBUTE_ID        integer               not null,
    ATTRIBUTE_NAME      varchar(80)           not null,
    ATTRIBUTE_DATATYPE  varchar(10)           not null,
    AGGREGATE_TYPE      varchar(10)           not null,
    PHYSICAL_TABLE      varchar(255)          not null,
    PHYSICAL_COLUMN     varchar(30)           not null,
    ATTRIBUTE_DISPLAY   integer               not null,
    ATTRIBUTE_TYPE      integer               not null,
    ATTRIBUTE_EX_RULE   varchar(255)          null    ,
    constraint PK_OA_INFO primary key (MODEL_ID, VIEW_ID, ATTRIBUTE_ID)
)
go

/* ============================================================ */
/*   Table: OVP_REL_INFO                                        */
/* ============================================================ */
create table OVP_REL_INFO
(
    MODEL_ID            integer               not null,
    VIEW_ID             integer               not null,
    PHY_RELATION_ID     integer               not null,
    PHY_REL_TYPE        integer               not null,
    PHY_TABLE_1         varchar(255)          not null,
    PHY_TABLE_2         varchar(255)          not null,
    constraint PK_OVP_REL_INFO primary key (MODEL_ID, VIEW_ID, PHY_RELATION_ID)
)
go

/* ============================================================ */
/*   Table: MOD_INFO                                            */
/* ============================================================ */
create table MOD_INFO
(
    MO_ID               integer               not null,
    MOD_ID              integer               not null,
    DIMENSION_ID        integer               null    ,
    MOD_TYPE            integer               not null,
    MOD_NAME            varchar(80)           not null,
    MOD_SEQ_NUMBER      integer               not null,
    constraint PK_MOD_INFO primary key (MO_ID, MOD_ID)
)
go

/* ============================================================ */
/*   Table: MSR_INFO                                            */
/* ============================================================ */
create table MSR_INFO
(
    MO_ID               integer               not null,
    MSR_ID              integer               not null,
    MSR_NAME            varchar(80)           not null,
    MSR_SEQ_NUMBER      integer               not null,
    MSR_VIEW_ID         integer               not null,
    MSR_ATTRIBUTE_ID    integer               not null,
    constraint PK_MSR_INFO primary key (MO_ID, MSR_ID)
)
go

/* ============================================================ */
/*   Table: MO_FILTERS                                          */
/* ============================================================ */
create table MO_FILTERS
(
    MO_ID               integer               not null,
    FLT_ID              integer               not null,
    FLT_TYPE            integer               not null,
    FLT_NAME            varchar(80)           null    ,
    constraint PK_MO_FILTERS primary key (MO_ID, FLT_ID)
)
go

/* ============================================================ */
/*   Table: DTR_INFO                                            */
/* ============================================================ */
create table DTR_INFO
(
    MO_ID               integer               not null,
    DTR_ID              integer               not null,
    DTR_NAME            varchar(80)           not null,
    DTR_SKIP_WIZARD     integer               not null,
    DTR_ROW_GOVERNOR    integer               not null,
    DTR_TIME_GOVERNOR   integer               not null,
    constraint PK_DTR_INFO primary key (MO_ID, DTR_ID)
)
go

/* ============================================================ */
/*   Table: MS_INFO                                             */
/* ============================================================ */
create table MS_INFO
(
    MO_ID               integer               not null,
    MOD_ID              integer               not null,
    MS_ID               integer               not null,
    MS_TYPE             integer               not null,
    MS_NAME             varchar(80)           not null,
    MS_PARENT_ID        integer               not null,
    MS_SEQ_NUMBER       integer               not null,
    MS_MSR_ID           integer               not null,
    MS_VIEW_ID          integer               not null,
    MS_ATTRIBUTE_ID     integer               not null,
    constraint PK_MS_INFO primary key (MO_ID, MOD_ID, MS_ID)
)
go

/* ============================================================ */
/*   Table: OD_DETAILS                                          */
/* ============================================================ */
create table OD_DETAILS
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    DIM_DETAIL_ID       integer               not null,
    VIEW_ID             integer               null    ,
    DIM_PARENT_VIEW_ID  integer               not null,
    constraint PK_OD_DETAILS primary key (MODEL_ID, DIMENSION_ID, DIM_DETAIL_ID)
)
go

/* ============================================================ */
/*   Table: OVL_REL_DETAILS                                     */
/* ============================================================ */
create table OVL_REL_DETAILS
(
    MODEL_ID            integer               not null,
    LOG_RELATION_ID     integer               not null,
    LOG_REL_DET_ID      integer               not null,
    LOG_ATTRIBUTE_1     integer               not null,
    LOG_ATTRIBUTE_2     integer               not null,
    constraint PK_OVL_REL_DETAILS primary key (MODEL_ID, LOG_RELATION_ID, LOG_REL_DET_ID)
)
go

/* ============================================================ */
/*   Table: OVP_REL_DETAILS                                     */
/* ============================================================ */
create table OVP_REL_DETAILS
(
    MODEL_ID            integer               not null,
    VIEW_ID             integer               not null,
    PHY_RELATION_ID     integer               not null,
    PHY_REL_DET_ID      integer               not null,
    PHY_COLUMN_1        varchar(30)           not null,
    PHY_COLUMN_2        varchar(30)           not null,
    constraint PK_OVP_REL_DETAILS primary key (MODEL_ID, VIEW_ID, PHY_RELATION_ID, PHY_REL_DET_ID)
)
go

/* ============================================================ */
/*   Table: MO_PROPERTIES                                       */
/* ============================================================ */
create table MO_PROPERTIES
(
    MO_ID               integer               not null,
    MOD_ID              integer               not null,
    MS_ID               integer               not null,
    PRP_CODE            integer               not null,
    PRP_CD_INS_NUMBER   integer               not null,
    PRP_CD_SEQ_NUMBER   integer               not null,
    PRP_VALUE           varchar(255)          null    ,
    PRP_VIEW_ID         integer               not null,
    PRP_ATTRIBUTE_ID    integer               not null,
    constraint PK_MO_PROPERTIES primary key (MO_ID, MOD_ID, MS_ID, PRP_CODE, PRP_CD_INS_NUMBER, PRP_CD_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MS_TX_RULE                                          */
/* ============================================================ */
create table MS_TX_RULE
(
    MO_ID               integer               not null,
    MOD_ID              integer               not null,
    MS_ID               integer               not null,
    TXR_SEQ_NUMBER      integer               not null,
    TXR_DEFINITION      varchar(255)          not null,
    constraint PK_MS_TX_RULE primary key (MO_ID, MOD_ID, MS_ID, TXR_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MSR_TX_RULE                                         */
/* ============================================================ */
create table MSR_TX_RULE
(
    MO_ID               integer               not null,
    MSR_ID              integer               not null,
    MSR_TXR_SEQ_NUMBER  integer               not null,
    MSR_TXR_DEFINITION  varchar(255)          not null,
    constraint PK_MSR_TX_RULE primary key (MO_ID, MSR_ID, MSR_TXR_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MB_TX_RULE                                          */
/* ============================================================ */
create table MB_TX_RULE
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    MODEL_BLOCK_ID      integer               not null,
    MB_ATTRIBUTE_ID     integer               not null,
    MB_TXR_SEQ_NUMBER   integer               not null,
    MB_TXR_DEFINITION   varchar(255)          not null,
    constraint PK_MB_TX_RULE primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID, MB_TXR_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MB_FILTER                                           */
/* ============================================================ */
create table MB_FILTER
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    MODEL_BLOCK_ID      integer               not null,
    MB_ATTRIBUTE_ID     integer               not null,
    MBF_SEQ_NUMBER      integer               not null,
    MBF_DEFINITION      varchar(255)          not null,
    constraint PK_MB_FILTER primary key (MODEL_ID, DIMENSION_ID, MODEL_BLOCK_ID, MB_ATTRIBUTE_ID, MBF_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MS_PREDICATES                                       */
/* ============================================================ */
create table MS_PREDICATES
(
    MO_ID               integer               not null,
    FLT_ID              integer               not null,
    MOD_ID              integer               not null,
    MS_ID               integer               not null,
    MS_PRD_TYPE         integer               not null,
    MS_PRD_SEQ_NUMBER   integer               not null,
    MS_PRD_DEFINITION   varchar(255)          not null,
    constraint PK_MS_PREDICATES primary key (MO_ID, FLT_ID, MOD_ID, MS_ID, MS_PRD_TYPE, MS_PRD_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MSR_PREDICATES                                      */
/* ============================================================ */
create table MSR_PREDICATES
(
    MO_ID               integer               not null,
    FLT_ID              integer               not null,
    MSR_ID              integer               not null,
    MSR_PRD_SEQ_NUMBER  integer               not null,
    MSR_PRD_DEFINITION  varchar(255)          not null,
    constraint PK_MSR_PREDICATES primary key (MO_ID, FLT_ID, MSR_ID, MSR_PRD_SEQ_NUMBER)
)
go

/* ============================================================ */
/*   Table: MO_INTERSECTION                                     */
/* ============================================================ */
create table MO_INTERSECTION
(
    MO_ID               integer               not null,
    DTR_ID              integer               not null,
    DTI_MOD_ID          integer               not null,
    DTI_MS_ID           integer               not null,
    constraint PK_MO_INTERSECTION primary key (MO_ID, DTR_ID, DTI_MOD_ID, DTI_MS_ID)
)
go

/* ============================================================ */
/*   Table: DTR_ATTRIBUTES                                      */
/* ============================================================ */
create table DTR_ATTRIBUTES
(
    MO_ID               integer               not null,
    DTR_ID              integer               not null,
    DTR_VIEW_ID         integer               not null,
    DTR_ATTRIBUTE_ID    integer               not null,
    DTR_DISP_ORDER      integer               not null,
    DTR_SORT_ORDER      integer               not null,
    DTR_ORDER_BY        integer               not null,
    constraint PK_DTR_ATTRIBUTES primary key (MO_ID, DTR_ID, DTR_VIEW_ID, DTR_ATTRIBUTE_ID)
)
go

/* ============================================================ */
/*   Table: JOIN_HINTS                                          */
/* ============================================================ */
create table JOIN_HINTS
(
    MODEL_ID            integer               not null,
    HINT_VIEW_ID        integer               not null,
    JOIN_TYPE           integer               not null,
    JOIN_ID             integer               not null,
    PHYSICAL_TABLE      varchar(255)          not null,
    HINT_TEXT           varchar(255)          not null,
    HINT_ID             integer               not null,
    constraint PK_JOIN_HINTS primary key (MODEL_ID, HINT_VIEW_ID, JOIN_TYPE, JOIN_ID, HINT_ID)
)
go

/* ============================================================ */
/*   Table: OM_DESCRIPTIONS                                     */
/* ============================================================ */
create table OM_DESCRIPTIONS
(
    MODEL_ID            integer               not null,
    DIMENSION_ID        integer               not null,
    VIEW_ID             integer               not null,
    ATTRIBUTE_ID        integer               not null,
    MODEL_BLOCK_ID      integer               not null,
    DESCRIPTION         varchar(255)          null    ,
    constraint PK_OM_DESCRIPTIONS primary key (MODEL_ID, DIMENSION_ID, VIEW_ID, ATTRIBUTE_ID, MODEL_BLOCK_ID)
)
go

/* ============================================================ */
/*   Table: MOD_ATTRIBUTES                                      */
/* ============================================================ */
create table MOD_ATTRIBUTES
(
    MO_ID               integer               not null,
    MOD_ID              integer               not null,
    MOD_ATTRIBUTE_ID    integer               not null,
    MOD_ATTR_DATATYPE   integer               not null,
    MOD_ATTR_ALIAS      varchar(80)           null    ,
    MOD_ATTR_TXR        varchar(255)          null    ,
    constraint PK_MOD_ATTRIBUTES primary key (MO_ID, MOD_ATTRIBUTE_ID)
)
go

/* ============================================================ */
/*   Table: MO_DESCRIPTIONS                                     */
/* ============================================================ */
create table MO_DESCRIPTIONS
(
    MO_ID               integer               not null,
    FLT_ID              integer               not null,
    MOD_ID              integer               not null,
    MS_ID               integer               not null,
    DESCRIPTIONS        varchar(255)          null    ,
    constraint PK_MO_DESCRIPTIONS primary key (MO_ID, FLT_ID, MOD_ID, MS_ID)
)
go

