#  setup.sh
# 
#  Script to run the DB2 OLAP installation.
#
#  If a filename is passed in, then the script will
#  launch the silent install.  Otherwise, the script
#  will launch the install with the user interface.
#

platform=`uname -s`
cd_dir=`pwd`
install_exe=olapi
silent_install_exe=olapr
file_name=$1

case "$platform" in

SunOS)  platform=solaris
		export LD_LIBRARY_PATH=$cd_dir/product
	;;
HP-UX)   platform=hpux
		export SHLIB_PATH=$SHLIB_PATH:$cd_dir/product
		export SHLIB_PATH=$SHLIB_PATH:/usr/lib
	;;
AIX)    platform=aix  
		export LIBPATH=$cd_dir/product
	;;
    
Linux)  platform=SQLLINUX  
	;;


*)      echo Unrecognized platform: "$platform"
        exit 1 ;;
esac

# lib_path=`printenv LIBPATH`
# echo The platform is $platform
# echo The cd_dir is $cd_dir
# echo The executable is $cd_dir/product/$install_exe
# echo The filename is $file_name 
# echo The libpath set is $lib_path
# exit 0


if [ -n "$file_name" ]; then

	if [ ! -f $cd_dir/product/$silent_install_exe ]; then
   		echo The installer cannot find the $cd_dir/product/$silent_install_exe file
        echo that is needed to run the installation. 
       	exit 1
	fi

	if [ ! -f $file_name ]; then
   		echo The installer cannot find the response file $file_name
    	echo The full path must be included. 
        exit 1
	fi
    
	$cd_dir/product/$silent_install_exe $file_name

else

	if [ ! -f $cd_dir/product/$install_exe ]; then
   		echo The installer cannot find the $cd_dir/product/$install_exe file
        echo that is needed to run the installation. 
       	exit 1
	fi


	$cd_dir/product/$install_exe
	
fi

exit 0
